import pandas as pd
import numpy as np
from sklearn import preprocessing
from numpy import mean
from numpy import std
from sklearn.model_selection import cross_val_score
from sklearn.model_selection import RepeatedStratifiedKFold
from sklearn.ensemble import RandomForestClassifier
import datetime, json
import joblib
import pickle
import matplotlib.pyplot as plt
from matplotlib.pyplot import plot,savefig
from xgboost import XGBRegressor as XGBR
import xgboost as xgb
import sklearn
from sklearn.model_selection import cross_val_score
import xgboost
from xgboost import XGBClassifier
import lightgbm as lgb
from sklearn import preprocessing
from sklearn.metrics import mean_squared_error
from lightgbm.sklearn import LGBMClassifier
from sklearn.model_selection import cross_val_score, train_test_split, GridSearchCV
from sklearn.metrics import mean_absolute_error,  make_scorer, accuracy_score
from sklearn.ensemble import GradientBoostingClassifier
from sklearn.metrics import log_loss
import warnings
warnings.filterwarnings('ignore')
np.random.seed(42)

def printlog(info):
    nowtime = datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')
    print("\n" + "==========" * 8 + "%s" % nowtime)
    print(info + '...\n\n')
# ================================================================================

# ================================================================================
printlog("step1: preparing data...")

f1 = open(r'F:/paper/code/1under_sample/under_sample_train.csv')
f2 = open(r'F:/paper/code/1under_sample/under_sample_test.csv')
f3 = open(r'F:/paper/code/1SMOTETomek_sample/SMOTETomek_sample_train.csv')
f4 = open(r'F:/paper/code/1SMOTETomek_sample/SMOTETomek_sample_test.csv')
f5 = open(r'F:/paper/code/1over_sample/over_sample_train.csv')
f6 = open(r'F:/paper/code/1over_sample/over_sample_test.csv')


train_u = pd.read_csv(f1)
test_u = pd.read_csv(f2)
train_s = pd.read_csv(f3)
test_s = pd.read_csv(f4)
train_o = pd.read_csv(f5)
test_o = pd.read_csv(f6)

train_u = np.array(train_u)
test_u = np.array(test_u)
train_s = np.array(train_s)
test_s = np.array(test_s)
train_o = np.array(train_o)
test_o = np.array(test_o)


train_xu = train_u[:, :-1]
train_yu = train_u[:, -1]
train_xs = train_s[:, :-1]
train_ys = train_s[:, -1]
train_xo = train_o[:, :-1]
train_yo = train_o[:, -1]

test_xu = test_u[:, :-1]
test_yu = test_u[:, -1]
test_xs = test_s[:, :-1]
test_ys = test_s[:, -1]
test_xo = test_o[:, :-1]
test_yo = test_o[:, -1]



min_max_scaler = preprocessing.MinMaxScaler()
train_xu = min_max_scaler.fit_transform(train_xu)
train_xs = min_max_scaler.fit_transform(train_xs)
train_xo = min_max_scaler.fit_transform(train_xo)

test_xu = min_max_scaler.fit_transform(test_xu)
test_xs = min_max_scaler.fit_transform(test_xs)
test_xo = min_max_scaler.fit_transform(test_xo)
# ================================================================================

# ================================================================================
printlog("step2: training model...")

# rf
model_rf = RandomForestClassifier(n_estimators=20,max_depth= 10)

model_rf = model_rf.fit(train_xs, train_ys)
model_rf_t = model_rf.fit(test_xs, test_ys)

joblib.dump(model_rf, 'rf.pkl')
joblib.dump(model_rf_t, 'rf_test.pkl')

from brokenaxes import brokenaxes

# rf_train
with open('rf.pkl', 'wb') as f:
    pickle.dump(model_rf, f)
    cv = RepeatedStratifiedKFold(n_splits=5, n_repeats=3, random_state=1)
    y_xu = model_rf.predict(train_xu)
    y_xs = model_rf.predict(train_xs)
    y_xo = model_rf.predict(train_xo)

    n_rf_u = cross_val_score(model_rf, X=train_xu, y=y_xu, cv=cv, scoring='accuracy',n_jobs=-1,error_score='raise')
    n_rf_s = cross_val_score(model_rf, X=train_xs, y=y_xs, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')
    n_rf_o = cross_val_score(model_rf, X=train_xo, y=y_xo, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')

    loss_rf_u = cross_val_score(model_rf, X=train_xu, y=y_xu, cv=cv, scoring='neg_log_loss', n_jobs=-1, error_score='raise')
    loss_rf_s = cross_val_score(model_rf, X=train_xs, y=y_xs, cv=cv, scoring='neg_log_loss', n_jobs=-1, error_score='raise')
    loss_rf_o = cross_val_score(model_rf, X=train_xo, y=y_xo, cv=cv,scoring='neg_log_loss',n_jobs=-1,error_score='raise')

    with open('rf_u_acc.txt', 'w') as f:
        f.writelines(str(mean(n_rf_u)))
    f.close()
    with open('rf_u_loss.txt', 'w') as f:
        f.writelines(str(mean(loss_rf_u)))
    f.close()

    with open('rf_s_acc.txt', 'w') as f:
        f.writelines(str(mean(n_rf_s)))
    f.close()
    with open('rf_s_loss.txt', 'w') as f:
        f.writelines(str(mean(loss_rf_s)))
    f.close()

    with open('rf_o_acc.txt', 'w') as f:
        f.writelines(str(mean(n_rf_o)))
    f.close()
    with open('rf_o_loss.txt', 'w') as f:
        f.writelines(str(mean(loss_rf_o)))
    f.close()

# # rf_test
with open('rf_test.pkl', 'wb') as f:
    pickle.dump(model_rf_t, f)
    cv = RepeatedStratifiedKFold(n_splits=5, n_repeats=3, random_state=1)
    y_xu = model_rf_t.predict(test_xu)
    y_xs = model_rf_t.predict(test_xs)
    y_xo = model_rf_t.predict(test_xo)

    n_rf_u = cross_val_score(model_rf_t, X=test_xu, y=y_xu, cv=cv, scoring='accuracy',n_jobs=-1,error_score='raise')
    n_rf_s = cross_val_score(model_rf_t, X=test_xs, y=y_xs, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')
    n_rf_o = cross_val_score(model_rf_t, X=test_xo, y=y_xo, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')

    loss_rf_u = cross_val_score(model_rf_t, X=test_xu, y=y_xu, cv=cv, scoring='neg_log_loss', n_jobs=-1, error_score='raise')
    loss_rf_s = cross_val_score(model_rf_t, X=test_xs, y=y_xs, cv=cv, scoring='neg_log_loss', n_jobs=-1, error_score='raise')
    loss_rf_o = cross_val_score(model_rf_t, X=test_xo, y=y_xo, cv=cv,scoring='neg_log_loss',n_jobs=-1,error_score='raise')

    with open('rf_u_acc_test.txt', 'w') as f:
        f.writelines(str(mean(n_rf_u)))
    f.close()
    with open('rf_u_loss_test.txt', 'w') as f:
        f.writelines(str(mean(loss_rf_u)))
    f.close()

    with open('rf_s_acc_test.txt', 'w') as f:
        f.writelines(str(mean(n_rf_s)))
    f.close()
    with open('rf_s_loss_test.txt', 'w') as f:
        f.writelines(str(mean(loss_rf_s)))
    f.close()

    with open('rf_o_acc_test.txt', 'w') as f:
        f.writelines(str(mean(n_rf_o)))
    f.close()
    with open('rf_o_loss_test.txt', 'w') as f:
        f.writelines(str(mean(loss_rf_o)))
    f.close()

model_xgb = XGBClassifier(
        n_estimators = 20,
        learning_rate = 0.05,
        max_depth = 10
)

model_xgb = model_xgb.fit(train_xs, train_ys)
model_xgb_t = model_xgb.fit(test_xs, test_ys)

joblib.dump(model_xgb, 'xgb.pkl')
joblib.dump(model_xgb_t, 'xgb_test.pkl')
# xgb train
with open('xgb.pkl', 'wb') as f:
    pickle.dump(model_xgb, f)
    cv = RepeatedStratifiedKFold(n_splits=5, n_repeats=3, random_state=1)
    y_xu = model_xgb.predict(train_xu)
    y_xs = model_xgb.predict(train_xs)
    y_xo = model_xgb.predict(train_xo)

    n_xgb_u = cross_val_score(model_xgb, X=train_xu, y=y_xu, cv=cv, scoring='accuracy',n_jobs=-1,error_score='raise')
    n_xgb_s = cross_val_score(model_xgb, X=train_xs, y=y_xs, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')
    n_xgb_o = cross_val_score(model_xgb, X=train_xo, y=y_xo, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')

    loss_xgb_u = cross_val_score(model_xgb, X=train_xu, y=y_xu, cv=cv, scoring='neg_log_loss', n_jobs=-1, error_score='raise')
    loss_xgb_s = cross_val_score(model_xgb, X=train_xs, y=y_xs, cv=cv, scoring='neg_log_loss', n_jobs=-1, error_score='raise')
    loss_xgb_o = cross_val_score(model_xgb, X=train_xo, y=y_xo, cv=cv,scoring='neg_log_loss',n_jobs=-1,error_score='raise')

    with open('xgb_u_acc.txt', 'w') as f:
        f.writelines(str(mean(n_xgb_u)))
    f.close()
    with open('xgb_u_loss.txt', 'w') as f:
        f.writelines(str(mean(loss_xgb_u)))
    f.close()

    with open('xgb_s_acc.txt', 'w') as f:
        f.writelines(str(mean(n_xgb_s)))
    f.close()
    with open('xgb_s_loss.txt', 'w') as f:
        f.writelines(str(mean(loss_xgb_s)))
    f.close()

    with open('xgb_o_acc.txt', 'w') as f:
        f.writelines(str(mean(n_xgb_o)))
    f.close()
    with open('xgb_o_loss.txt', 'w') as f:
        f.writelines(str(mean(loss_xgb_o)))
    f.close()
# xgb test
with open('xgb_test.pkl', 'wb') as f:
    pickle.dump(model_xgb_t, f)
    cv = RepeatedStratifiedKFold(n_splits=5, n_repeats=3, random_state=1)
    y_xu = model_xgb_t.predict(test_xu)
    y_xs = model_xgb_t.predict(test_xs)
    y_xo = model_xgb_t.predict(test_xo)

    n_xgb_u = cross_val_score(model_xgb_t, X=test_xu, y=y_xu, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')
    n_xgb_s = cross_val_score(model_xgb_t, X=test_xs, y=y_xs, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')
    n_xgb_o = cross_val_score(model_xgb_t, X=test_xo, y=y_xo, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')

    loss_xgb_u = cross_val_score(model_xgb_t, X=test_xu, y=y_xu, cv=cv, scoring='neg_log_loss', n_jobs=-1,
                                error_score='raise')
    loss_xgb_s = cross_val_score(model_xgb_t, X=test_xs, y=y_xs, cv=cv, scoring='neg_log_loss', n_jobs=-1,
                                error_score='raise')
    loss_xgb_o = cross_val_score(model_xgb_t, X=test_xo, y=y_xo, cv=cv, scoring='neg_log_loss', n_jobs=-1,
                                error_score='raise')

    with open('xgb_u_acc_test.txt', 'w') as f:
        f.writelines(str(mean(n_xgb_u)))
    f.close()
    with open('xgb_u_loss_test.txt', 'w') as f:
        f.writelines(str(mean(loss_xgb_u)))
    f.close()

    with open('xgb_s_acc_test.txt', 'w') as f:
        f.writelines(str(mean(n_xgb_s)))
    f.close()
    with open('xgb_s_loss_test.txt', 'w') as f:
        f.writelines(str(mean(loss_xgb_s)))
    f.close()

    with open('xgb_o_acc_test.txt', 'w') as f:
        f.writelines(str(mean(n_xgb_o)))
    f.close()
    with open('xgb_o_loss_test.txt', 'w') as f:
        f.writelines(str(mean(loss_xgb_o)))
    f.close()

model_lig = lgb.LGBMClassifier(
        n_estimators = 20,
        learning_rate = 0.1,
        max_depth = 10,
        num_leaves = 100,
        colsample_bytree = 0.8,
        subsample = 0.8)
model_lig = model_lig.fit(train_xs, train_ys)
model_lig_t = model_lig.fit(test_xs, test_ys)

joblib.dump(model_lig, 'lig.pkl')
joblib.dump(model_lig_t, 'lig_test.pkl')

# lightGBM train
with open('lig.pkl', 'wb') as f:
    pickle.dump(model_lig, f)
    cv = RepeatedStratifiedKFold(n_splits=5, n_repeats=3, random_state=1)
    y_xu = model_lig.predict(train_xu)
    y_xs = model_lig.predict(train_xs)
    y_xo = model_lig.predict(train_xo)

    n_lig_u = cross_val_score(model_lig, X=train_xu, y=y_xu, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')
    n_lig_s = cross_val_score(model_lig, X=train_xs, y=y_xs, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')
    n_lig_o = cross_val_score(model_lig, X=train_xo, y=y_xo, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')

    loss_lig_u = cross_val_score(model_lig, X=train_xu, y=y_xu, cv=cv, scoring='neg_log_loss', n_jobs=-1,
                                 error_score='raise')
    loss_lig_s = cross_val_score(model_lig, X=train_xs, y=y_xs, cv=cv, scoring='neg_log_loss', n_jobs=-1,
                                 error_score='raise')
    loss_lig_o = cross_val_score(model_lig, X=train_xo, y=y_xo, cv=cv, scoring='neg_log_loss', n_jobs=-1,
                                 error_score='raise')

    with open('lig_u_acc.txt', 'w') as f:
        f.writelines(str(mean(n_lig_u)))
    f.close()
    with open('lig_u_loss.txt', 'w') as f:
        f.writelines(str(mean(loss_lig_u)))
    f.close()

    with open('lig_s_acc.txt', 'w') as f:
        f.writelines(str(mean(n_lig_s)))
    f.close()
    with open('lig_s_loss.txt', 'w') as f:
        f.writelines(str(mean(loss_lig_s)))
    f.close()

    with open('lig_o_acc.txt', 'w') as f:
        f.writelines(str(mean(n_lig_o)))
    f.close()
    with open('lig_o_loss.txt', 'w') as f:
        f.writelines(str(mean(loss_lig_o)))
    f.close()

# lightGBM test
with open('lig_test.pkl', 'wb') as f:
    pickle.dump(model_lig_t, f)
    cv = RepeatedStratifiedKFold(n_splits=5, n_repeats=3, random_state=1)
    y_xu = model_lig_t.predict(test_xu)
    y_xs = model_lig_t.predict(test_xs)
    y_xo = model_lig_t.predict(test_xo)

    n_lig_u = cross_val_score(model_lig_t, X=test_xu, y=y_xu, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')
    n_lig_s = cross_val_score(model_lig_t, X=test_xs, y=y_xs, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')
    n_lig_o = cross_val_score(model_lig_t, X=test_xo, y=y_xo, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')

    loss_lig_u = cross_val_score(model_lig_t, X=test_xu, y=y_xu, cv=cv, scoring='neg_log_loss', n_jobs=-1,
                                 error_score='raise')
    loss_lig_s = cross_val_score(model_lig_t, X=test_xs, y=y_xs, cv=cv, scoring='neg_log_loss', n_jobs=-1,
                                 error_score='raise')
    loss_lig_o = cross_val_score(model_lig_t, X=test_xo, y=y_xo, cv=cv, scoring='neg_log_loss', n_jobs=-1,
                                 error_score='raise')

    with open('lig_u_acc_test.txt', 'w') as f:
        f.writelines(str(mean(n_lig_u)))
    f.close()
    with open('lig_u_loss_test.txt', 'w') as f:
        f.writelines(str(mean(loss_lig_u)))
    f.close()

    with open('lig_s_acc_test.txt', 'w') as f:
        f.writelines(str(mean(n_lig_s)))
    f.close()
    with open('lig_s_loss_test.txt', 'w') as f:
        f.writelines(str(mean(loss_lig_s)))
    f.close()

    with open('lig_o_acc_test.txt', 'w') as f:
        f.writelines(str(mean(n_lig_o)))
    f.close()
    with open('lig_o_loss_test.txt', 'w') as f:
        f.writelines(str(mean(loss_lig_o)))
    f.close()

model_gdbt = GradientBoostingClassifier(learning_rate=0.1, subsample=0.8, max_depth=10, n_estimators=20)

model_gdbt = model_gdbt.fit(train_xs, train_ys)
model_gdbt_t = model_gdbt.fit(test_xs,test_ys)

joblib.dump(model_gdbt, 'gdbt.pkl')
joblib.dump(model_gdbt_t, 'gdbt_test.pkl')

# GDBT train
with open('gdbt.pkl', 'wb') as f:
    pickle.dump(model_gdbt, f)
    cv = RepeatedStratifiedKFold(n_splits=5, n_repeats=3, random_state=1)
    y_xu = model_gdbt.predict(train_xu)
    y_xs = model_gdbt.predict(train_xs)
    y_xo = model_gdbt.predict(train_xo)

    n_gdbt_u = cross_val_score(model_gdbt, X=train_xu, y=y_xu, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')
    n_gdbt_s = cross_val_score(model_gdbt, X=train_xs, y=y_xs, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')
    n_gdbt_o = cross_val_score(model_gdbt, X=train_xo, y=y_xo, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')

    loss_gdbt_u = cross_val_score(model_gdbt, X=train_xu, y=y_xu, cv=cv, scoring='neg_log_loss', n_jobs=-1,
                                 error_score='raise')
    loss_gdbt_s = cross_val_score(model_gdbt, X=train_xs, y=y_xs, cv=cv, scoring='neg_log_loss', n_jobs=-1,
                                 error_score='raise')
    loss_gdbt_o = cross_val_score(model_gdbt, X=train_xo, y=y_xo, cv=cv, scoring='neg_log_loss', n_jobs=-1,
                                 error_score='raise')

    with open('gdbt_u_acc.txt', 'w') as f:
        f.writelines(str(mean(n_gdbt_u)))
    f.close()
    with open('gdbt_u_loss.txt', 'w') as f:
        f.writelines(str(mean(loss_gdbt_u)))
    f.close()

    with open('gdbt_s_acc.txt', 'w') as f:
        f.writelines(str(mean(n_gdbt_s)))
    f.close()
    with open('gdbt_s_loss.txt', 'w') as f:
        f.writelines(str(mean(loss_gdbt_s)))
    f.close()

    with open('gdbt_o_acc.txt', 'w') as f:
        f.writelines(str(mean(n_gdbt_o)))
    f.close()
    with open('gdbt_o_loss.txt', 'w') as f:
        f.writelines(str(mean(loss_gdbt_o)))
    f.close()


# GDBT test
with open('gdbt_test.pkl', 'wb') as f:
    pickle.dump(model_gdbt_t, f)
    cv = RepeatedStratifiedKFold(n_splits=5, n_repeats=3, random_state=1)
    y_xu = model_gdbt_t.predict(test_xu)
    y_xs = model_gdbt_t.predict(test_xs)
    y_xo = model_gdbt_t.predict(test_xo)

    n_gdbt_u = cross_val_score(model_gdbt_t, X=test_xu, y=y_xu, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')
    n_gdbt_s = cross_val_score(model_gdbt_t, X=test_xs, y=y_xs, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')
    n_gdbt_o = cross_val_score(model_gdbt_t, X=test_xo, y=y_xo, cv=cv, scoring='accuracy', n_jobs=-1, error_score='raise')

    loss_gdbt_u = cross_val_score(model_gdbt_t, X=test_xu, y=y_xu, cv=cv, scoring='neg_log_loss', n_jobs=-1,
                                 error_score='raise')
    loss_gdbt_s = cross_val_score(model_gdbt_t, X=test_xs, y=y_xs, cv=cv, scoring='neg_log_loss', n_jobs=-1,
                                 error_score='raise')
    loss_gdbt_o = cross_val_score(model_gdbt_t, X=test_xo, y=y_xo, cv=cv, scoring='neg_log_loss', n_jobs=-1,
                                 error_score='raise')

    with open('gdbt_u_acc_test.txt', 'w') as f:
        f.writelines(str(mean(n_gdbt_u)))
    f.close()
    with open('gdbt_u_loss_test.txt', 'w') as f:
        f.writelines(str(mean(loss_gdbt_u)))
    f.close()

    with open('gdbt_s_acc_test.txt', 'w') as f:
        f.writelines(str(mean(n_gdbt_s)))
    f.close()
    with open('gdbt_s_loss_test.txt', 'w') as f:
        f.writelines(str(mean(loss_gdbt_s)))
    f.close()

    with open('gdbt_o_acc_test.txt', 'w') as f:
        f.writelines(str(mean(n_gdbt_o)))
    f.close()
    with open('gdbt_o_loss_test.txt', 'w') as f:
        f.writelines(str(mean(loss_gdbt_o)))
    f.close()