import pandas as pd
from sklearn import preprocessing
from numpy import mean
from numpy import std
import datetime
from catboost import CatBoostClassifier, Pool
import lightgbm as lgb
from xgboost import XGBClassifier
from sklearn.model_selection import cross_val_score
from sklearn.ensemble import RandomForestClassifier, GradientBoostingClassifier
from sklearn.model_selection import StratifiedKFold
from sklearn.model_selection import RepeatedStratifiedKFold
import numpy as np
import matplotlib.pyplot as plt
from matplotlib.pyplot import plot,savefig
import warnings
warnings.filterwarnings('ignore')
np.random.seed(42)
from keras.models import Sequential
from keras.layers import Input, Dense
import h5py

f1 = open(r'F:/paper/code/1over_sample/over_sample_train.csv')
f2 = open(r'F:/paper/code/1over_sample/over_sample_test.csv')
# f1 = open(r'F:/paper/code/1under_sample/under_sample_train.csv')
# f2 = open(r'F:/paper/code/1under_sample/under_sample_test.csv')
# f1 = open(r'F:/paper/code/1SMOTETomek_sample/SMOTETomek_sample_train.csv')
# f2 = open(r'F:/paper/code/1SMOTETomek_sample/SMOTETomek_sample_test.csv')

train=pd.read_csv(f1)
test=pd.read_csv(f2)
train = np.array(train)
test = np.array(test)

min_max_scaler = preprocessing.MinMaxScaler()
train = min_max_scaler.fit_transform(train)
test= min_max_scaler.fit_transform(test)

trainx = train[:,:-1]
trainy = train[:,-1]

testx = test[:,:-1]
testy = test[:,-1]

model=Sequential()
h1 = Dense(20, activation='sigmoid')
model.add(h1)
h2 =Dense(100, activation='relu')
model.add(h2)
h3 = Dense(50, activation='relu')
model.add(h3)
h4 = Dense(20, activation='relu')
model.add(h4)
h5 = Dense(6, activation='softmax')
model.add(h5)

model.compile( optimizer='adam',loss='sparse_categorical_crossentropy', metrics=['accuracy']) #编译模型，loss损失函数，优化方法adam/sgd sparse_categorical_crossentropy
history = model.fit(trainx, trainy, epochs=1000, validation_data=(trainx, trainy))

save_path = './lll.h5'

model_path = './lll.h5'
print("读取模型中...")
with h5py.File(model_path, 'r') as f:
    loss, accuracy = model.evaluate(trainx, trainy)
    print('loss:', loss)
    print('accuracy:', accuracy)
    with open('loss.txt', 'w') as f:
        f.writelines(str(loss))
    f.close()
    with open('accuracy.txt', 'w') as f:
        f.writelines(str(accuracy))
    f.close()

history_test = model.fit(testx, testy, epochs=1000, validation_data=(testx, testy))
save_path_t = './lll_test.h5'
model.save(save_path_t)
model_path_t = './lll_test.h5'
print("读取模型中...")
with h5py.File(model_path_t, 'r') as f:
    loss_test, accuracy_test = model.evaluate(testx, testy)
    print('loss_test:',loss_test)
    print('accuracy_test:',accuracy_test)

    with open('loss_test.txt', 'w') as f:
        f.writelines(str(loss_test))
    f.close()
    with open('accuracy_test.txt', 'w') as f:
        f.writelines(str(accuracy_test))
    f.close()


